diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.46/src/internet/test/global-route-manager-impl-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/global-route-manager-impl-test-suite.cc	2026-02-16 16:08:49.623230000 -0800
@@ -441,85 +732,175 @@
     Ipv4AddressHelper address;
     address.SetBase("10.1.1.0", "255.255.255.248");
     Ipv4InterfaceContainer i012 = address.Assign(d012);
+
+    Ipv6AddressHelper addressv6;
+    addressv6.SetBase("2001:1::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i012v6 = addressv6.Assign(d012);
 }
 
 void
-LanRoutesTestCase::BuildLsa()
+LanRoutesTestCase::BuildLsav4()
 {
     // we manually create the link state database, we could have used BuildRoutingTables() but this
     // way testing the GlobalRouteManagerImpl without the involvement of GLobalRouter makes it
     // easier to debug each individually
 
     // router 0
-    auto lr0 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::TransitNetwork,
-                                           "10.1.1.1",
-                                           "10.1.1.1",
-                                           1);
-    auto lsa0 = new GlobalRoutingLSA();
-    lsa0->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lr0 = new GlobalRoutingLinkRecord<Ipv4Manager>(
+        GlobalRoutingLinkRecord<Ipv4Manager>::TransitNetwork,
+        "10.1.1.1",
+        "10.1.1.1",
+        1);
+    auto lsa0 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa0->AddLinkRecord(lr0);
     lsa0->SetLinkStateId("0.0.0.0");
     lsa0->SetAdvertisingRouter("0.0.0.0");
     lsa0->SetNode(nodes.Get(0));
-    m_lsas.push_back(lsa0);
+    m_lsasv4.push_back(lsa0);
 
     // router 1
-    auto lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::TransitNetwork,
-                                           "10.1.1.1",
-                                           "10.1.1.2",
-                                           1);
-    auto lsa1 = new GlobalRoutingLSA();
-    lsa1->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lr1 = new GlobalRoutingLinkRecord<Ipv4Manager>(
+        GlobalRoutingLinkRecord<Ipv4Manager>::TransitNetwork,
+        "10.1.1.1",
+        "10.1.1.2",
+        1);
+    auto lsa1 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa1->AddLinkRecord(lr1);
     lsa1->SetLinkStateId("0.0.0.1");
     lsa1->SetAdvertisingRouter("0.0.0.1");
     lsa1->SetNode(nodes.Get(1));
-    m_lsas.push_back(lsa1);
+    m_lsasv4.push_back(lsa1);
 
     // router 2
-    auto lr2 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::TransitNetwork,
-                                           "10.1.1.1",
-                                           "10.1.1.3",
-                                           1);
-    auto lsa2 = new GlobalRoutingLSA();
-    lsa2->SetLSType(GlobalRoutingLSA::RouterLSA);
+    auto lr2 = new GlobalRoutingLinkRecord<Ipv4Manager>(
+        GlobalRoutingLinkRecord<Ipv4Manager>::TransitNetwork,
+        "10.1.1.1",
+        "10.1.1.3",
+        1);
+    auto lsa2 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
     lsa2->AddLinkRecord(lr2);
     lsa2->SetLinkStateId("0.0.0.2");
     lsa2->SetAdvertisingRouter("0.0.0.2");
     lsa2->SetNode(nodes.Get(2));
-    m_lsas.push_back(lsa2);
+    m_lsasv4.push_back(lsa2);
 
     // router0 is the designated router for the LAN. it also exports the network LSA
-    auto lsa0network = new GlobalRoutingLSA();
-    lsa0network->SetLSType(GlobalRoutingLSA::NetworkLSA);
+    auto lsa0network = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa0network->SetLSType(GlobalRoutingLSA<Ipv4Manager>::NetworkLSA);
     lsa0network->SetLinkStateId("10.1.1.1");
     lsa0network->SetAdvertisingRouter("0.0.0.0");
     lsa0network->AddAttachedRouter("10.1.1.1");
     lsa0network->AddAttachedRouter("10.1.1.2");
     lsa0network->AddAttachedRouter("10.1.1.3");
     lsa0network->SetNetworkLSANetworkMask("255.255.255.248");
-    m_lsas.push_back(lsa0network); // note the index of the network lsa
+    m_lsasv4.push_back(lsa0network); // note the index of the network lsa
+}
+
+void
+LanRoutesTestCase::BuildLsav6()
+{
+    // we manually create the link state database, we could have used BuildRoutingTables() but this
+    // way testing the GlobalRouteManagerImpl without the involvement of GLobalRouter makes it
+    // easier to debug each individually
+
+    // router 0
+    auto lr0 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::TransitNetwork,
+        "2001:1::200:ff:fe00:1", // link id ->  Link ID is the ip address of the designated router
+        "2001:1::200:ff:fe00:1", // link data is this routers own Global Unicast ip address
+        "fe80::200:ff:fe00:1",   // the link local data is the link local address of this router for
+                                 // this link
+        1);
+    auto lsa0 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa0->AddLinkRecord(lr0);
+    lsa0->SetLinkStateId("::ffff:0.0.0.0");
+    lsa0->SetAdvertisingRouter("::ffff:0.0.0.0");
+    lsa0->SetNode(nodes.Get(0));
+    m_lsasv6.push_back(lsa0);
+
+    // router 1
+    auto lr1 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::TransitNetwork,
+        "2001:1::200:ff:fe00:1", // link id ->  Link ID is the ip address of the designated router
+        "2001:1::200:ff:fe00:2", // link data is this routers own Global Unicast ip address
+        "fe80::200:ff:fe00:2",   // the link local data is the link local address of this router for
+                                 // this link
+        1);
+    auto lsa1 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa1->AddLinkRecord(lr1);
+    lsa1->SetLinkStateId("::ffff:0.0.0.1");
+    lsa1->SetAdvertisingRouter("::ffff:0.0.0.1");
+    lsa1->SetNode(nodes.Get(1));
+    m_lsasv6.push_back(lsa1);
+
+    // router 2
+    auto lr2 = new GlobalRoutingLinkRecord<Ipv6Manager>(
+        GlobalRoutingLinkRecord<Ipv6Manager>::TransitNetwork,
+        "2001:1::200:ff:fe00:1",
+        "2001:1::200:ff:fe00:3",
+        "fe80::200:ff:fe00:3",
+        1);
+    auto lsa2 = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv6Manager>::RouterLSA);
+    lsa2->AddLinkRecord(lr2);
+    lsa2->SetLinkStateId("::ffff:0.0.0.2");
+    lsa2->SetAdvertisingRouter("::ffff:0.0.0.2");
+    lsa2->SetNode(nodes.Get(2));
+    m_lsasv6.push_back(lsa2);
+
+    // router0 is the designated router for the LAN. it also exports the network LSA
+    auto lsa0network = new GlobalRoutingLSA<Ipv6Manager>();
+    lsa0network->SetLSType(GlobalRoutingLSA<Ipv6Manager>::NetworkLSA);
+    lsa0network->SetLinkStateId("2001:1::200:ff:fe00:1");
+    lsa0network->SetAdvertisingRouter("::ffff:0.0.0.0");
+    lsa0network->AddAttachedRouter("2001:1::200:ff:fe00:1");
+    lsa0network->AddAttachedRouter("2001:1::200:ff:fe00:2");
+    lsa0network->AddAttachedRouter("2001:1::200:ff:fe00:3");
+
+    lsa0network->SetNetworkLSANetworkMask(Ipv6Prefix(64));
+    m_lsasv6.push_back(lsa0network); // note the index of the network lsa
 }
 
 void
 LanRoutesTestCase::DoRun()
 {
-    BuildLsa();
+    BuildLsav4();
     // insert the LSAs into the GlobalRouteManagerLSDB
-    auto srmlsdb = new GlobalRouteManagerLSDB();
+    auto srmlsdb = new GlobalRouteManagerLSDB<Ipv4Manager>();
 
-    srmlsdb->Insert(m_lsas[0]->GetLinkStateId(), m_lsas[0]);
-    srmlsdb->Insert(m_lsas[1]->GetLinkStateId(), m_lsas[1]);
-    srmlsdb->Insert(m_lsas[2]->GetLinkStateId(), m_lsas[2]);
-    srmlsdb->Insert(m_lsas[3]->GetLinkStateId(), m_lsas[3]);
+    srmlsdb->Insert(m_lsasv4[0]->GetLinkStateId(), m_lsasv4[0]);
+    srmlsdb->Insert(m_lsasv4[1]->GetLinkStateId(), m_lsasv4[1]);
+    srmlsdb->Insert(m_lsasv4[2]->GetLinkStateId(), m_lsasv4[2]);
+    srmlsdb->Insert(m_lsasv4[3]->GetLinkStateId(), m_lsasv4[3]);
 
     // create the GlobalRouteManagerImpl
-    auto srm = new GlobalRouteManagerImpl();
-    srm->DebugUseLsdb(srmlsdb);
+    auto srmv4 = new GlobalRouteManagerImpl<Ipv4Manager>();
+    srmv4->DebugUseLsdb(srmlsdb);
 
-    srm->DebugSPFCalculate(m_lsas[0]->GetLinkStateId()); // fill the routing table for node 0
+    srmv4->DebugSPFCalculate(m_lsasv4[0]->GetLinkStateId()); // fill the routing table for node 0
 
-    // now the tests-----------------------
+    // now for ipv6
+    BuildLsav6();
+    // insert the LSAs into the GlobalRouteManagerLSDB
+    auto srmlsdbv6 = new GlobalRouteManagerLSDB<Ipv6Manager>();
+
+    srmlsdbv6->Insert(m_lsasv6[0]->GetLinkStateId(), m_lsasv6[0]);
+    srmlsdbv6->Insert(m_lsasv6[1]->GetLinkStateId(), m_lsasv6[1]);
+    srmlsdbv6->Insert(m_lsasv6[2]->GetLinkStateId(), m_lsasv6[2]);
+    srmlsdbv6->Insert(m_lsasv6[3]->GetLinkStateId(), m_lsasv6[3]);
+
+    // create the GlobalRouteManagerImpl
+    auto srmv6 = new GlobalRouteManagerImpl<Ipv6Manager>();
+    srmv6->DebugUseLsdb(srmlsdbv6);
+
+    srmv6->DebugSPFCalculate(m_lsasv6[0]->GetLinkStateId()); // fill the routing table for node 0
+
+    // now the tests for IPv4-----------------------
 
     Ptr<Ipv4L3Protocol> ip0 = nodes.Get(0)->GetObject<Ipv4L3Protocol>();
     NS_TEST_ASSERT_MSG_NE(ip0, nullptr, "Error-- no Ipv4 object at node 0");
@@ -539,14 +920,38 @@
                           Ipv4Address("0.0.0.0"),
                           "Error-- wrong gateway for network route");
 
+    // now the tests for IPv6-----------------------
+
+    Ptr<Ipv6L3Protocol> ip0v6 = nodes.Get(0)->GetObject<Ipv6L3Protocol>();
+    NS_TEST_ASSERT_MSG_NE(ip0v6, nullptr, "Error-- no Ipv6 object at node 0");
+    Ptr<Ipv6RoutingProtocol> routing0v6 = ip0v6->GetRoutingProtocol();
+    NS_TEST_ASSERT_MSG_NE(routing0v6, nullptr, "Error-- no Ipv6 routing protocol object at node 0");
+    Ptr<Ipv6GlobalRouting> globalRouting0v6 = routing0v6->GetObject<Ipv6GlobalRouting>();
+    NS_TEST_ASSERT_MSG_NE(globalRouting0v6,
+                          nullptr,
+                          "Error-- no Ipv6GlobalRouting object at node 0");
+
+    // The only route to check is the network route
+    uint32_t nRoutes0v6 = globalRouting0v6->GetNRoutes();
+    NS_TEST_ASSERT_MSG_EQ(nRoutes0v6, 1, "Error-- Network route not found for node 0");
+    Ipv6RoutingTableEntry* routev6 = globalRouting0v6->GetRoute(0);
+    NS_TEST_ASSERT_MSG_EQ(routev6->GetDest(),
+                          Ipv6Address("2001:1::"),
+                          "Error-- wrong destination for network route");
+    NS_TEST_ASSERT_MSG_EQ(routev6->GetGateway(),
+                          Ipv6Address("::"),
+                          "Error-- wrong gateway for network route");
+
     Simulator::Run();
 
     Simulator::Stop(Seconds(3));
     Simulator::Destroy();
     // This delete clears the srm, which deletes the LSDB, which clears
     // all of the LSAs, which each destroys the attached LinkRecords.
-    delete srm;
-    GlobalRouteManager::ResetRouterId();
+    delete srmv4;
+    delete srmv6;
+    GlobalRouteManager<Ipv4Manager>::ResetRouterId();
+    GlobalRouteManager<Ipv6Manager>::ResetRouterId();
 }
 
 /**
@@ -568,14 +973,27 @@
      *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
      *       GlobalRouteManagerLSDB.Each node exports a router LSA.
      */
-    void BuildLsa();
+    void BuildLsav4();
+
+    /**
+     *@brief Builds the LSAs for the topology. These LSAs are manually created and inserted into the
+     *       GlobalRouteManagerLSDB.Each node exports a router LSA.
+     */
+    void BuildLsav6();
 
     /**
      * @brief Helper function that checks the output of the routing path
      * and increments the corresponding route counter.
      * @param route The routing path to check
      */
-    void IncrementCount(Ptr<Ipv4Route>& route);
+    void IncrementCountv4(Ptr<Ipv4Route>& route);
+
+    /**
+     * @brief Helper function that checks the output of the routing path
+     * and increments the corresponding route counter.
+     * @param route The routing path to check
+     */
+    void IncrementCountv6(Ptr<Ipv6Route>& route);
     /**
      * @brief function that checks the routing table entries for the expected output.
      * @param globalroutingprotocol The routing protocol for the node whose routing table is to be
@@ -583,13 +1001,27 @@
      * @param dests The expected destinations.
      * @param gws The expected gateways.
      */
-    void CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
-                     std::vector<Ipv4Address>& dests,
-                     std::vector<Ipv4Address>& gws);
-    uint32_t route1 = 0; //!< Counter to keep track of the number of times route1 is used
-    uint32_t route2 = 0; //!< Counter to keep track of the number of times route2 is used
-    NodeContainer nodes; //!< NodeContainer to hold the nodes in the topology
-    std::vector<GlobalRoutingLSA*> m_lsas; //!< The LSAs for the topology
+    void CheckRoutesv4(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                       std::vector<Ipv4Address>& dests,
+                       std::vector<Ipv4Address>& gws);
+
+    /**
+     * @brief function that checks the routing table entries for the expected output.
+     * @param globalroutingprotocol The routing protocol for the node whose routing table is to be
+     * checked.
+     * @param dests The expected destinations.
+     * @param gws The expected gateways.
+     */
+    void CheckRoutesv6(Ptr<Ipv6GlobalRouting>& globalroutingprotocol,
+                       std::vector<Ipv6Address>& dests,
+                       std::vector<Ipv6Address>& gws);
+    uint32_t route1v4 = 0; //!< Counter to keep track of the number of times route1 is used for ipv4
+    uint32_t route2v4 = 0; //!< Counter to keep track of the number of times route2 is used for ipv4
+    uint32_t route1v6 = 0; //!< Counter to keep track of the number of times route1 is used for ipv6
+    uint32_t route2v6 = 0; //!< Counter to keep track of the number of times route2 is used for ipv6
+    NodeContainer nodes;   //!< NodeContainer to hold the nodes in the topology
+    std::vector<GlobalRoutingLSA<Ipv4Manager>*> m_lsasv4; //!< The LSAs for the topology
+    std::vector<GlobalRoutingLSA<Ipv6Manager>*> m_lsasv6; //!< The LSAs for the topology
 };
 
 RandomEcmpTestCase::RandomEcmpTestCase()
@@ -601,6 +1033,8 @@
 RandomEcmpTestCase::DoSetup()
 {
     Config::SetDefault("ns3::Ipv4GlobalRouting::RandomEcmpRouting", BooleanValue(true));
+    Config::SetDefault("ns3::Ipv6GlobalRouting::RandomEcmpRouting", BooleanValue(true));
+
     /*
     //   Creating a Simple topology with 4 nodes and 3 links
     //
@@ -622,8 +1056,10 @@
     nodes.Create(4);
 
     Ipv4GlobalRoutingHelper globalhelper;
+    Ipv6GlobalRoutingHelper globalhelperv6;
     InternetStackHelper stack;
     stack.SetRoutingHelper(globalhelper);
+    stack.SetRoutingHelper(globalhelperv6);
     stack.Install(nodes);
     SimpleNetDeviceHelper devHelper;
     devHelper.SetNetDevicePointToPointMode(true);
@@ -653,12 +1089,22 @@
 
     address.SetBase("10.1.4.0", "255.255.255.252");
     Ipv4InterfaceContainer i23 = address.Assign(d23);
+
+    Ipv6AddressHelper addressv6;
+    addressv6.SetBase("2001:1::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i01v6 = addressv6.Assign(d01);
+    addressv6.SetBase("2001:2::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i02v6 = addressv6.Assign(d02);
+    addressv6.SetBase("2001:3::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i13v6 = addressv6.Assign(d13);
+    addressv6.SetBase("2001:4::", Ipv6Prefix(64));
+    Ipv6InterfaceContainer i23v6 = addressv6.Assign(d23);
 }
 
 void
-RandomEcmpTestCase::CheckRoutes(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
-                                std::vector<Ipv4Address>& dests,
-                                std::vector<Ipv4Address>& gws)
+RandomEcmpTestCase::CheckRoutesv4(Ptr<Ipv4GlobalRouting>& globalroutingprotocol,
+                                  std::vector<Ipv4Address>& dests,
+                                  std::vector<Ipv4Address>& gws)
 {
     // check each individual routes destination and gateway
     for (uint32_t i = 0; i < globalroutingprotocol->GetNRoutes(); i++)
@@ -671,47 +1117,79 @@
 }
 
 void
-RandomEcmpTestCase::IncrementCount(Ptr<Ipv4Route>& route)
+RandomEcmpTestCase::CheckRoutesv6(Ptr<Ipv6GlobalRouting>& globalroutingprotocol,
+                                  std::vector<Ipv6Address>& dests,
+                                  std::vector<Ipv6Address>& gws)
+{
+    // check each individual routes destination and gateway
+    for (uint32_t i = 0; i < globalroutingprotocol->GetNRoutes(); i++)
+    {
+        Ipv6RoutingTableEntry* route = globalroutingprotocol->GetRoute(i);
+        NS_LOG_DEBUG("dest " << route->GetDest() << " gw " << route->GetGateway());
+        NS_TEST_ASSERT_MSG_EQ(route->GetDest(), dests[i], "Error-- wrong destination");
+        NS_TEST_ASSERT_MSG_EQ(route->GetGateway(), gws[i], "Error-- wrong gateway");
+    }
+}
+
+void
+RandomEcmpTestCase::IncrementCountv4(Ptr<Ipv4Route>& route)
 {
     if (route->GetGateway() == Ipv4Address("10.1.1.2"))
     {
-        route1++;
+        route1v4++;
     }
     else if (route->GetGateway() == Ipv4Address("10.1.2.2"))
     {
-        route2++;
+        route2v4++;
+    }
+}
+
+void
+RandomEcmpTestCase::IncrementCountv6(Ptr<Ipv6Route>& route)
+{
+    if (route->GetGateway() == Ipv6Address("fe80::200:ff:fe00:2"))
+    {
+        route1v6++;
+    }
+    else if (route->GetGateway() == Ipv6Address("fe80::200:ff:fe00:6"))
+    {
+        route2v6++;
     }
 }
 
 void
-RandomEcmpTestCase::BuildLsa()
+RandomEcmpTestCase::BuildLsav4()
 {
     // we manually create the link state database, we could have used BuildRoutingTables() but this
     // way testing the GlobalRouteManagerImpl without the involvement of GLobalRouter makes it
     // easier to debug each individually
 
     // router 0
-    auto lr0 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.1",
-                                           "10.1.1.1",
-                                           1);
-    auto lr1 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.2",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lr2 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.2",
-                                           "10.1.2.1",
-                                           1);
-    auto lr3 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.2.2",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lsa0 = new GlobalRoutingLSA();
-    lsa0->SetLSType(GlobalRoutingLSA::RouterLSA);
-    lsa0->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+    auto lr0 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.1",
+                                                 "10.1.1.1",
+                                                 1);
+    auto lr1 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.1.2",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lr2 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.2",
+                                                 "10.1.2.1",
+                                                 1);
+    auto lr3 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.2.2",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lsa0 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa0->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
+    lsa0->SetStatus(GlobalRoutingLSA<Ipv4Manager>::LSA_SPF_NOT_EXPLORED);
     lsa0->SetLinkStateId("0.0.0.0");
     lsa0->SetAdvertisingRouter("0.0.0.0");
     lsa0->SetNode(nodes.Get(0));
@@ -719,30 +1197,34 @@
     lsa0->AddLinkRecord(lr1);
     lsa0->AddLinkRecord(lr2);
     lsa0->AddLinkRecord(lr3);
-    m_lsas.push_back(lsa0);
+    m_lsasv4.push_back(lsa0);
 
     // router 1
-    auto lr4 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.0",
-                                           "10.1.1.2",
-                                           1);
-    auto lr5 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.1.1",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lr6 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.3",
-                                           "10.1.3.1",
-                                           1);
-    auto lr7 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.3.2",
-                                           "255.255.255.252",
-                                           1);
-
-    auto lsa1 = new GlobalRoutingLSA();
-    lsa1->SetLSType(GlobalRoutingLSA::RouterLSA);
-    lsa1->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+    auto lr4 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.0",
+                                                 "10.1.1.2",
+                                                 1);
+    auto lr5 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.1.1",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lr6 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.3",
+                                                 "10.1.3.1",
+                                                 1);
+    auto lr7 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.3.2",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lsa1 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa1->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
+    lsa1->SetStatus(GlobalRoutingLSA<Ipv4Manager>::LSA_SPF_NOT_EXPLORED);
     lsa1->SetLinkStateId("0.0.0.1");
     lsa1->SetAdvertisingRouter("0.0.0.1");
     lsa1->SetNode(nodes.Get(1));
@@ -750,29 +1232,33 @@
     lsa1->AddLinkRecord(lr5);
     lsa1->AddLinkRecord(lr6);
     lsa1->AddLinkRecord(lr7);
-    m_lsas.push_back(lsa1);
+    m_lsasv4.push_back(lsa1);
 
     // router 2
-    auto lr8 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                           "0.0.0.0",
-                                           "10.1.2.2",
-                                           1);
-    auto lr9 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                           "10.1.2.1",
-                                           "255.255.255.252",
-                                           1);
-    auto lr10 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                            "0.0.0.3",
-                                            "10.1.4.1",
-                                            1);
-    auto lr11 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                            "10.1.4.2",
-                                            "255.255.255.252",
-                                            1);
-
-    auto lsa2 = new GlobalRoutingLSA();
-    lsa2->SetLSType(GlobalRoutingLSA::RouterLSA);
-    lsa2->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+    auto lr8 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.0",
+                                                 "10.1.2.2",
+                                                 1);
+    auto lr9 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.2.1",
+                                                 "255.255.255.252",
+                                                 1);
+    auto lr10 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.3",
+                                                 "10.1.4.1",
+                                                 1);
+    auto lr11 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.4.2",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lsa2 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa2->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
+    lsa2->SetStatus(GlobalRoutingLSA<Ipv4Manager>::LSA_SPF_NOT_EXPLORED);
     lsa2->SetLinkStateId("0.0.0.2");
     lsa2->SetAdvertisingRouter("0.0.0.2");
     lsa2->SetNode(nodes.Get(2));
@@ -780,29 +1266,33 @@
     lsa2->AddLinkRecord(lr9);
     lsa2->AddLinkRecord(lr10);
     lsa2->AddLinkRecord(lr11);
-    m_lsas.push_back(lsa2);
+    m_lsasv4.push_back(lsa2);
 
     // router 3
-    auto lr12 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                            "0.0.0.1",
-                                            "10.1.3.2",
-                                            1);
-    auto lr13 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                            "10.1.3.1",
-                                            "255.255.255.252",
-                                            1);
-    auto lr14 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::PointToPoint,
-                                            "0.0.0.2",
-                                            "10.1.4.2",
-                                            1);
-    auto lr15 = new GlobalRoutingLinkRecord(GlobalRoutingLinkRecord::StubNetwork,
-                                            "10.1.4.1",
-                                            "255.255.255.252",
-                                            1);
-
-    auto lsa3 = new GlobalRoutingLSA();
-    lsa3->SetLSType(GlobalRoutingLSA::RouterLSA);
-    lsa3->SetStatus(GlobalRoutingLSA::LSA_SPF_NOT_EXPLORED);
+    auto lr12 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.1",
+                                                 "10.1.3.2",
+                                                 1);
+    auto lr13 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.3.1",
+                                                 "255.255.255.252",
+                                                 1);
+    auto lr14 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::PointToPoint,
+                                                 "0.0.0.2",
+                                                 "10.1.4.2",
+                                                 1);
+    auto lr15 =
+        new GlobalRoutingLinkRecord<Ipv4Manager>(GlobalRoutingLinkRecord<Ipv4Manager>::StubNetwork,
+                                                 "10.1.4.1",
+                                                 "255.255.255.252",
+                                                 1);
+
+    auto lsa3 = new GlobalRoutingLSA<Ipv4Manager>();
+    lsa3->SetLSType(GlobalRoutingLSA<Ipv4Manager>::RouterLSA);
+    lsa3->SetStatus(GlobalRoutingLSA<Ipv4Manager>::LSA_SPF_NOT_EXPLORED);
     lsa3->SetLinkStateId("0.0.0.3");
     lsa3->SetAdvertisingRouter("0.0.0.3");
     lsa3->SetNode(nodes.Get(3));
